<?php
/**
 * Created by Luiz Filho
 */

namespace SCM\Model\Repository;

use Doctrine\ORM\EntityRepository;

class Complemento extends EntityRepository {

    public function retornaProdutos($nrorg, $filiais, $cdgrupprod, $qtdInicial, $qtdFinal) {
        $params = array(
            'NRORG' => $nrorg,
            'CDFILIAL' => $filiais,
            'ROWNUMINI' => $qtdInicial,
            'ROWNUMFIM' => $qtdFinal,
        );

        if ($cdgrupprod == 'T') {

            $sql = "SELECT NMPRODUTO, CDPRODUTO, CDARVPROD, SGUNIDADE, TIPOPRODUTO, CDFILIAL, CONTADOR
                FROM (SELECT NMPRODUTO, CDPRODUTO, CDARVPROD, SGUNIDADE, TIPOPRODUTO,CDFILIAL, ROWNUM  AS CONTADOR
                    FROM (SELECT NMPRODUTO, CDPRODUTO, CDARVPROD, SGUNIDADE, TIPOPRODUTO, CDFILIAL
                        FROM (
                            SELECT PRODUTO.NMPRODUTO, PRODUTO.CDPRODUTO, PRODUTO.CDARVPROD, PRODUTO.SGUNIDADE,
                            DECODE(PRODUTO.CDPRODUTO, PRODUTO.CDPRODESTO, 'E', 'C') AS TIPOPRODUTO, PRODFILI.CDFILIAL
                            FROM PRODFILI
                            JOIN PRODUTO ON PRODFILI.CDPRODUTO = PRODUTO.CDPRODUTO AND PRODUTO.NRORG = PRODFILI.NRORG
                            WHERE CDFILIAL = :CDFILIAL
                            AND PRODFILI.IDPRODATIV = 'A'
                            AND PRODUTO.CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) FROM PRODUTO)
                            AND PRODUTO.IDPRODATIVPR = 'S'
                            AND PRODUTO.NRORG = :NRORG
                            ORDER BY NMPRODUTO, CDPRODUTO
                        )
                        GROUP BY NMPRODUTO, CDPRODUTO, CDARVPROD, SGUNIDADE, TIPOPRODUTO, CDFILIAL
                        ORDER BY NMPRODUTO, CDPRODUTO)
                       ORDER BY CONTADOR, NMPRODUTO, CDPRODUTO
                    ) X
                WHERE (CONTADOR BETWEEN :ROWNUMINI AND :ROWNUMFIM)
                ORDER BY NMPRODUTO, CDPRODUTO
                ";
        } else {

            $sql = "SELECT NMPRODUTO, CDPRODUTO, CDARVPROD, SGUNIDADE, CDFILIAL, TIPOPRODUTO
                FROM (SELECT NMPRODUTO, CDPRODUTO, CDARVPROD, SGUNIDADE, CDFILIAL, TIPOPRODUTO, ROWNUM  AS CONTADOR
                    FROM (SELECT NMPRODUTO, CDPRODUTO, CDARVPROD, TIPOPRODUTO, SGUNIDADE, CDFILIAL
                    FROM (
                        SELECT PRODUTO.NMPRODUTO, PRODUTO.CDPRODUTO, PRODUTO.CDARVPROD, PRODUTO.SGUNIDADE, DECODE(PRODUTO.CDPRODUTO, PRODUTO.CDPRODESTO, 'E', 'C') AS TIPOPRODUTO, PRODFILI.CDFILIAL
                        FROM PRODUTO
                        JOIN PRODFILI ON PRODUTO.CDPRODUTO = PRODFILI.CDPRODUTO AND PRODUTO.NRORG = PRODFILI.NRORG
                        JOIN PRSUBGRPROD ON PRODUTO.CDPRODUTO = PRSUBGRPROD.CDPRODUTO AND PRODUTO.NRORG = PRSUBGRPROD.NRORG
                        WHERE PRODUTO.NRORG = :NRORG
                        AND PRODUTO.IDPRODATIVPR = 'S'
                        AND PRODUTO.CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) FROM PRODUTO)
                        AND (PRSUBGRPROD.CDGRUPPROD = :CDGRUPPROD)
                        AND PRSUBGRPROD.CDFILISUBGR = 'P'
                        AND PRODFILI.IDPRODATIV = 'A'
                        AND PRODFILI.CDFILIAL = :CDFILIAL
                    )
                    GROUP BY NMPRODUTO, CDPRODUTO, CDARVPROD, TIPOPRODUTO, SGUNIDADE, CDFILIAL
                  )X
                )
                WHERE (CONTADOR BETWEEN :ROWNUMINI AND :ROWNUMFIM)
                ORDER BY NMPRODUTO, CDPRODUTO";

            $params['CDGRUPPROD'] = $cdgrupprod;
        }

        $query = $this->getEntityManager()->getConnection()->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        return $result;
    }

    public function retornaJustificativas($nrorg) {

        $sql = "SELECT
            CDJUSTSOL, DSJUSTSOL AS DSJUSTOPER, DSJUSTSOL AS DSJUSTSOLEXT
          FROM JUSTSOLI
          WHERE NRORG = :NRORG
          ORDER BY DSJUSTSOL";

        $params = array(
            'NRORG' => $nrorg,
        );

        $query = $this->getEntityManager()->getConnection()->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        return $result;
    }

    public function retornaProdutosInventarios($nrorg, $filiais) {

        $sql = "SELECT PF.CDFILIAL, PF.CDPRODUTO, P.NMPRODUTO, P.CDARVPROD, SGUNIDADE
            FROM PRODFILI PF JOIN PRODUTO P ON PF.CDPRODUTO = P.CDPRODUTO AND PF.NRORG = P.NRORG
            WHERE CDFILIAL IN ($filiais)
            AND PF.NRORG = :NRORG
            AND IDPRODATIV  = 'A'
            AND IDPRODATIVPR = 'S'
            AND IDCNTRESTOQ = 'S'
            AND P.CDPRODUTO = CDPRODESTO
            ORDER BY P.NMPRODUTO ASC";

        $params = array(
            'NRORG' => $nrorg
        );

        $query = $this->getEntityManager()->getConnection()->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        return $result;
    }

    public function retornaGruposProduto($nrorg){

        $sql = "SELECT CDGRUPPROD, NMGRUPPROD FROM GRUPPROD WHERE NRORG = :NRORG ORDER BY CDGRUPPROD";

        $params = array(
            'NRORG' => $nrorg
        );

        $query = $this->getEntityManager()->getConnection()->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        return $result;
    }

    public function retornaMascaraProduto($nrorg){
        $sql = "SELECT CDPICTPROD FROM PARAMGERAL WHERE NRORG = :NRORG";

        $params = array(
            'NRORG' => $nrorg
        );

        $query = $this->getEntityManager()->getConnection()->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        return $result;

    }

    public function retornaUsuarioAtivo($dsemailoper, $nrorg) {
        $sql = "SELECT IDOPERATIVO FROM OPERADOR WHERE NRORG = :NRORG AND DSEMAILOPER = :DSEMAILOPER";

        $params = array(
            'NRORG' => $nrorg,
            'DSEMAILOPER' => $dsemailoper,
        );

        $query = $this->getEntityManager()->getConnection()->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        return $result;
    }
    
    public function retornaOperadorAtivo($cdoperador, $nrorg) {
        $sql = "SELECT IDOPERATIVO FROM OPERADOR WHERE NRORG = :NRORG AND CDOPERADOR = :CDOPERADOR";

        $params = array(
            'NRORG' => $nrorg,
            'CDOPERADOR' => $dsemailoper,
        );

        $query = $this->getEntityManager()->getConnection()->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        return $result;
    }

    public function retornaQtdTotalProdutos($nrorg, $filiais, $cdgrupprod) {
        $params = array(
            'NRORG' => $nrorg,
            'CDFILIAL' => $filiais,
        );

        if ($cdgrupprod == 'T') {

            $sql = "SELECT COUNT(*) AS QTD
                    FROM (
                        SELECT PRODUTO.NMPRODUTO, PRODUTO.CDPRODUTO, PRODUTO.CDARVPROD, PRODUTO.SGUNIDADE,
                        DECODE(PRODUTO.CDPRODUTO, PRODUTO.CDPRODESTO, 'E', 'C') AS TIPOPRODUTO, PRODFILI.CDFILIAL
                        FROM PRODFILI
                        JOIN PRODUTO ON PRODFILI.CDPRODUTO = PRODUTO.CDPRODUTO AND PRODUTO.NRORG = PRODFILI.NRORG
                        WHERE CDFILIAL = :CDFILIAL
                        AND PRODFILI.IDPRODATIV = 'A'
                        AND PRODUTO.CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) FROM PRODUTO)
                        AND PRODUTO.IDPRODATIVPR = 'S'
                        AND PRODUTO.NRORG = :NRORG
                    )";
        } else {

            $sql = "SELECT COUNT(*) AS QTD
                    FROM (
                        SELECT PRODUTO.NMPRODUTO, PRODUTO.CDPRODUTO, PRODUTO.CDARVPROD, PRODUTO.SGUNIDADE, PRODUTO.CDPRODESTO, PRODFILI.CDFILIAL
                        FROM PRODUTO
                        JOIN PRODFILI ON PRODUTO.CDPRODUTO = PRODFILI.CDPRODUTO AND PRODUTO.NRORG = PRODFILI.NRORG
                        JOIN PRSUBGRPROD ON PRODUTO.CDPRODUTO = PRSUBGRPROD.CDPRODUTO AND PRODUTO.NRORG = PRSUBGRPROD.NRORG
                        WHERE PRODUTO.NRORG = :NRORG
                        AND PRODUTO.IDPRODATIVPR = 'S'
                        AND PRODUTO.CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) FROM PRODUTO)
                        AND (PRSUBGRPROD.CDGRUPPROD = :CDGRUPPROD)
                        AND PRSUBGRPROD.CDFILISUBGR = 'P'
                        AND PRODFILI.IDPRODATIV = 'A'
                        AND PRODFILI.CDFILIAL = :CDFILIAL
                        GROUP BY PRODUTO.NMPRODUTO, PRODUTO.CDPRODUTO, PRODUTO.CDARVPROD, PRODUTO.SGUNIDADE, PRODUTO.CDPRODESTO, PRODFILI.CDFILIAL
                    )";

            $params['CDGRUPPROD'] = $cdgrupprod;
        }

        $query = $this->getEntityManager()->getConnection()->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        return $result;
    }
}