<?php
/**
 * Created by Luiz Filho
 */

namespace SCM\Model\Repository;

use Doctrine\ORM\EntityRepository;

class Inventarios extends EntityRepository {

    public function retornaUltimoInventario($nrorg, $filiais) {
        $dataSet = array();
	  	$sql = "SELECT I.CDFILIAL, I.NRINVENTRETI, NRITINVENTRETI, I.CDPRODUTO, P.NMPRODUTO, I.NRORG
            FROM ITEMINVENTRETI I, PRODUTO P,
            (SELECT MAX(NRINVENTRETI) NRINVENTRETI, CDFILIAL
                    FROM INVENTARIORETI
                    WHERE CDFILIAL = :CDFILIAL
                    AND NRORG      = :NRORG
                    GROUP BY CDFILIAL
                ) NR
            WHERE I.NRINVENTRETI = NR.NRINVENTRETI
            AND I.CDFILIAL  = NR.CDFILIAL
            AND P.CDPRODUTO = I.CDPRODUTO
            AND I.NRORG = :NRORG
            ORDER BY P.NMPRODUTO ASC";

	  	$params = array(
            'NRORG' => $nrorg,
		    'CDFILIAL' => '',
		);
        foreach ($filiais as $filial) {
            $params['CDFILIAL'] = $filial;
            $query = $this->getEntityManager()->getConnection()->prepare($sql);
            $query->execute($params);
            $dataSet = array_merge($dataSet, $query->fetchAll());
        }
        return $dataSet;
    }

    public function retornaProximoCodigoInventario($nrorg, $filiais) {
        $dataSet = array();
        $sql = "SELECT LPAD((NVL(MAX(NRINVENTRETI),0) + 1),10,'0') PROXIMOCODIGO,
            CDFILIAL
            FROM INVENTARIORETI
            WHERE CDFILIAL = :CDFILIAL
            AND NRORG = :NRORG
            GROUP BY CDFILIAL";

        $params = array(
            'NRORG' => $nrorg,
            'CDFILIAL' => '',
        );
        foreach ($filiais as $filial) {
            $params['CDFILIAL'] = $filial;
            $query = $this->getEntityManager()->getConnection()->prepare($sql);
            $query->execute($params);
            $dataSet = array_merge($dataSet, $query->fetchAll());
        }
        return $dataSet;
    }

    public function retornaProximoCodigoProdutoInventario($nrorg, $filiais) {
        $dataSet = array();
        $sql = "SELECT LPAD((NVL(MAX(NRITINVENTRETI),0) + 1),4,'0') PROXIMOCODIGO,
            CDFILIAL, NRINVENTRETI
            FROM ITEMINVENTRETI
            WHERE CDFILIAL = :CDFILIAL
            AND NRORG = :NRORG
            GROUP BY CDFILIAL, NRINVENTRETI";

        $params = array(
            'NRORG' => $nrorg,
            'CDFILIAL' => '',
        );
        foreach ($filiais as $filial) {
            $params['CDFILIAL'] = $filial;
            $query = $this->getEntityManager()->getConnection()->prepare($sql);
            $query->execute($params);
            $dataSet = array_merge($dataSet, $query->fetchAll());
        }
        return $dataSet;
    }

    public function retornaDatasInventarios($nrorg, $filiais) {
        $dataSet = array();
        $sql = "SELECT NRINVENTRETI,
              DSINVENTRETI,
              CDFILIAL,
              TO_CHAR(DTINVENTRETI, 'DD/MM/YYYY') AS DTINVENTRETI
            FROM INVENTARIORETI
            WHERE CDFILIAL = :CDFILIAL
            AND NRORG = :NRORG
            ORDER BY TO_DATE(DTINVENTRETI, 'DD/MM/YYYY')";

        $params = array(
            'NRORG' => $nrorg,
            'CDFILIAL' => '',
        );
        foreach ($filiais as $filial) {
            $params['CDFILIAL'] = $filial;
            $query = $this->getEntityManager()->getConnection()->prepare($sql);
            $query->execute($params);
            $dataSet = array_merge($dataSet, $query->fetchAll());
        }
        return $dataSet;
    }

    public function retornaProdutosInventarios($nrorg, $cdfilial) {

        $sql = "SELECT ROWNUM, CDFILIAL, NRINVENTRETI, NRITINVENTRETI, QTITINVENTRETI, I.CDPRODUTO,
            P.NMPRODUTO, I.CDOPERINCLUSAO, I.DTINCLUSAO, I.CDOPERULTATU, I.DTULTATU
            FROM ITEMINVENTRETI I, PRODUTO P
            WHERE P.CDPRODUTO = I.CDPRODUTO
            AND I.CDFILIAL  IN ($cdfilial)
            AND I.NRORG = :NRORG
            ORDER BY P.NMPRODUTO ASC";

        $params = array(
            'NRORG' => $nrorg,
        );

        $query = $this->getEntityManager()->getConnection()->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        return $result;
    }

}