<?php

namespace SCM\Services;

/**
 * An static class
 */
class JWT {

    const SECRET_KEY = "TSECKHNOIOSLA";

    public static function generateToken($payload) {
        $header= array(
            "typ" => "JWT"
        );
        $unsignedToken = self::base64_url_encode(json_encode((object) $header)) . "." . self::base64_url_encode(json_encode((object) $payload));
        return $unsignedToken . "." . self::sign($unsignedToken);
    }

    public static function validateToken($token, $sessionName) {
        try {
            $sections  = explode(".", $token);
            $content   = $sections[0] . "." . $sections[1];
            $signature = $sections[2];
            if (self::sign($content) != $signature) {
                throw new \Exception();
            }
            return true;
        }
        catch (\Exception $e) {
            self::unsetSessionCookie($sessionName);
            return false;
        }
    }

    public static function getTokenData($token) {
        $segments = explode('.', $token);
        list($headb64, $bodyb64, $cryptob64) = $segments;
        return json_decode(self::base64_url_decode($bodyb64), true);
    }

    public static function setSessionCookie($name, $value = "", $time = 0, $path = "/", $domain = "", $secure = false, $httponly = false) {
        setcookie($name, $value, $time, $path, $domain, $secure, $httponly);
    }

    public static function unsetSessionCookie($name) {
        self::setSessionCookie($name);
    }

    private static function sign($data) {
        return self::base64_url_encode(hash_hmac("sha256", $data, self::SECRET_KEY, true));
    }

    private static function base64_url_encode($val) {
        return strtr(base64_encode($val), '+/=', '-_,');
    }

    private static function base64_url_decode($val) {
        return base64_decode(strtr($val, '-_,', '+/='));
    }
}