import { Metadata, IDictionary, Loader } from '@zeedhi/core';
import { Card, ICard } from '@zeedhi/common';

export class InventariosController {
  private utilities = Loader.getInstance('Utilities');

  public showInventarioForm = false;

  public adicionar() {
    // console.log(component);
  }

  public generateInventariosCard() {
    const parentCard = Metadata.getInstance<Card>('inventarios-card');
    let inventarios = this.utilities.getItemLocalStorage('Inventarios');
    if (inventarios.length === 0) {
      const test = [
        {
          DSINVENTRETI: 'Teste',
          DTINVENTRETI: 'Hoje',
        },
      ];
      inventarios = test;
    }
    const inventariosToAppend: ICard[] = [];
    inventarios.forEach((inventario: IDictionary, index: number) => {
      inventariosToAppend.push({
        name: `card-inventario-${index}`,
        component: 'ZdCard',
        hover: true,
        children: [
          {
            name: `title-${inventario.DSINVENTRETI}`,
            component: 'ZdText',
            text: inventario.DSINVENTRETI,
            tag: 'h3',
          },
          {
            name: `subtitle-${inventario.DSINVENTRETI}`,
            component: 'ZdText',
            text: inventario.DTINVENTRETI,
          },
        ],
      });
    });
    const parentCardTitle = parentCard.children[0];
    // .find((child) => child.component === 'TekCardTitle');
    parentCard.children = [parentCardTitle, ...inventariosToAppend];
  }
}
