import {
  Config, Singleton, Http, IDictionary, Loader,
} from '@zeedhi/core';
// import { useStorage } from '@vueuse/core';

@Singleton
export class LoginController {
  private importacaoController = Loader.getInstance('ImportacaoController');

  private db = Loader.getInstance('DB');

  private utilities = Loader.getInstance('Utilities');

  get logo() {
    return Config.env.product.logoUrl;
  }

  get backgroundImgUrl() {
    const url = Config.env.loginBackgroundImgUrl;
    return `url(${url})`;
  }

  get endPoint() {
    return Config.env.loginEndPoint;
  }

  public async setLocalStorageUser(userData: IDictionary) {
    const filter = [
      {
        name: 'CDOPERADOR',
        value: localStorage.getItem('CDOPERADOR') || '',
        operator: '=',
      },
    ];
    const loadData = [
      // this.utilities.startIndexedDB(),
      Http.post('/Filial', { requestType: 'FilterData', filter }),
      Http.post('/GruposProduto'),
      // Http.post('/User/info'),
    ];
    if (userData) loadData.push(Http.post('/userInfo', { requestType: 'Row', row: {} }));
    await Promise.all(loadData).then((result: IDictionary) => {
      this.utilities.setItemLocalStorage('Units', result[0].data.dataset.Units);
      this.utilities.setItemLocalStorage('GruposProduto', result[1].data.dataset.GruposProduto);
      if (userData) {
        const userInfo = result[2].data?.dataset?.userInfo;
        if (userInfo) {
          localStorage.setItem('CDFILIALLOGADA', userInfo.CDFILIALSELECIONADA);
          localStorage.setItem('NMFILIALLOGADA', userInfo.NMFILIAL);
        }
      }
    });
  }
}
