var ExportationErrorLogController = function(ScreenService, SchoolMealsUtil, UIManager, templateManager) {

    /**
     * Open dependent registers of
     * selected error log entry.
     */
    this.openErrorLogDetails = () => {
        let errorDetails = templateManager.container.getWidget("errorProductList");
        let selectedReg = templateManager.container.currentItem;

        setFilterOnErrorDetail(selectedReg, errorDetails);
        UIManager.goToWidget(errorDetails);
    };

    /**
     * Set filter into register detail widget to 
     * show dependent registers related to error.
     * 
     * @param {Object} errorRegister 
     * @param {Object} errorWidget 
     */
    const setFilterOnErrorDetail = (errorRegister, errorWidget) => {
        errorWidget.dataSourceFilter = [{
            "name": "PARENT",
            "operator": "=",
            "value": errorRegister.ID
        }];
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('ExportationErrorLogController', ExportationErrorLogController);
});
