var LoginService = function(restEngine, ScreenService, SchoolMealsUtil) {

    this.login = function(email, password) {
        var concate_usr = [{
                'name': 'email',
                'value': email,
                'operator': '='
            },
            {
                'name': 'password',
                'value': password,
                'operator': '='
            }
        ];
        return restEngine.request("/Login", {
            requestType: "FilterData",
            filter: concate_usr
        });
    };

    this.changeUnit = function(userData) {
        return restEngine.request("/changeFilial", {
            requestType: "Row",
            row: userData
        });
    };

    this.checkLoginValidity = function(userData) {
        return restEngine.request("/checkLoginValidity", {
            requestType: "Row",
            row: userData
        });
    };

    this.checkServerRepository = () => restEngine.request('/ServerRepository', {
        requestType: "Row",
        row: {}
    });

    this.getProductsGroups = () => restEngine.request('/GruposProduto', {
        requestType: "FilterData",
        filter: [{
            "name": "NRORG",
            "operator": "=",
            "value": getLocalVar('userData').NRORG
        }]
    });

    /**
     * Get product code mask from server.
     * 
     * @returns {Promise}
     */
    this.getProductMask = () => restEngine.request('/MascaraProduto', {
        requestType: "FilterData",
        filter: [{
            "name": "NRORG",
            "operator": "=",
            "value": getLocalVar('userData').NRORG
        }]
    }).then(result => result.dataset.MascaraProduto.CDPICTPROD.replace(/([^\.])/g, "A"));

    /**
     * Logout current user, and clear
     * it data at system memory.
     * 
     * @return {Promise}
     */
    this.logout = () => {
        setLocalVar('isLogged', false);
        setLocalVar('userData', '');
        SchoolMealsUtil.clearUserIDBData();
        ScreenService.openWindow('login');
    };

    /**
     * Check if user is active.
     * 
     * @param {String} mail User mail.
     * @param {String|Number} nrorg
     * 
     * @return {Promise}
     */
    this.checkActiveUser = function(mail, nrorg) {
        return restEngine.request('/UsuarioAtivo', {
            "requestType": "FilterData",
            "filter": [{
                    "name": "DSEMAILOPER",
                    "operator": "=",
                    "value": mail
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": nrorg
                }
            ]
        }, null, null, null, null, 300000).then(function(result) {
            return result.dataset.usuario.ativo;
        });
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('LoginService', LoginService);
});
