let PDFUtil = function(ScreenService) {
    window._ss = ScreenService;

    const titleHEXString = '#000000';
    const subTitleHEXString = '#111111';
    const textHEXString = '#333333';
    const xOffset = 4;
    let currentY = 10;

    this.resetY = () => currentY = 10;

    this.renderTitle = (jsPDFDoc, title, fontSize = 22) => {
        preventOverflow(jsPDFDoc);
        jsPDFDoc.setFontSize(fontSize);
        jsPDFDoc.setTextColor(titleHEXString);
        var splitTitle = jsPDFDoc.splitTextToSize(title, 100);
        jsPDFDoc.text(xOffset, currentY, splitTitle);
        currentY += (7 * splitTitle.length) + 7;
    };

    this.renderSubTitle = (jsPDFDoc, subTitle, verticalOffset = 5, fontSize = 14) => {
        preventOverflow(jsPDFDoc);
        jsPDFDoc.setFontSize(fontSize);
        jsPDFDoc.setTextColor(subTitleHEXString);
        var splitSubTitle = jsPDFDoc.splitTextToSize(subTitle, 100);
        jsPDFDoc.text(xOffset, currentY, splitSubTitle);
        currentY += (verticalOffset * splitSubTitle.length) + verticalOffset;
    };

    this.renderText = (jsPDFDoc, text, verticalOffset = 5, fontSize = 11) => {
        preventOverflow(jsPDFDoc);
        jsPDFDoc.setFontSize(fontSize);
        jsPDFDoc.setTextColor(textHEXString);
        var splitText = jsPDFDoc.splitTextToSize(text, 100);
        jsPDFDoc.text(xOffset, currentY, splitText);
        currentY += (verticalOffset * splitText.length) + verticalOffset;
    };

    var preventOverflow = (jsPDFDoc) => {
        var pageHeight = jsPDFDoc.internal.pageSize.height;
        if (currentY >= pageHeight) {
            jsPDFDoc.addPage();
            currentY = 10; // Restart height position
        }
    };

    this.fromDataArray = (data) => {
        let newDoc = new jsPDF('portrait', 'mm', [297.64, 500.53]);
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('PDFUtil', PDFUtil);
});
