'use strict';

function CheckboxFieldsController($scope) {

    function isNullorUndefined(itemToTest) {
        if (itemToTest === undefined || itemToTest === null) {
            return true;
        }
        return false;
    }

    $scope.getDisplayField = (field, data) => {
        let valueShow = field.valueShow;
        if (Array.isArray(valueShow)) {
            let ret = '';
            valueShow.forEach(v => {
                if(data[v]){
                    ret += data[v];
                    ret += ' ';
                }
            });
            return ret;
        } else {
            return data[field.valueShow];
        }
    };

    $scope.addOrRemoveOption = (field, data, $e) => {
        let curRow = $scope.widget.currentRow;
        let elem = $($e.currentTarget);
        let inpt = elem.children('input.chbox');
        inpt.attr('checked', true);
        let isChecked = inpt.prop("checked");

        if(isChecked){
            field.dataSource.addCheckedRows(data);
        } else {
            field.dataSource.removeCheckedRows(data);
        }
        curRow[field.name] = field.dataSource.checkedRows;
    };

    let _isInFieldDataArray = (elementToFind, arrayToSearch, strict = false) => {
        if(!strict){
            let found = false;
            let searchKeys = $scope.field.dataSource.getVO().localKey || [$scope.field.name];
            found = arrayToSearch.some((arrayElement) => 
                searchKeys.every(key => arrayElement[key] === elementToFind[key])
            );
            return found;
        } else {
            return (arrayToSearch.indexOf(elementToFind) !== -1);
        }
    };

    /**
     * @param {Array} rows array of objects or pks only
     * @param {boolean} strict 
     */
    $scope.field.setCheckedRows = (rows, strict = false) => {
        if(rows.length && typeof rows[0] !== 'object'){ // if a array of primitives is received 
            rows = rows.map(row => {
                let newRow = {};
                newRow[$scope.field.name] = row;
                return newRow
            })
        }
        $scope.field.dataSource.checkedRows = [];
        $scope.field.dataSource.addCheckedRows(rows);
        $scope.widget.currentRow[$scope.field.name] = $scope.field.dataSource.checkedRows;
        let checkboxElements = $scope.field.element[0].querySelectorAll('input.chbox[type=checkbox]');
        checkboxElements.forEach((checkboxElement, index) => {
            let checkboxData = $scope.field.dataSource.data[index];                
            checkboxElement.checked = _isInFieldDataArray(checkboxData, rows, strict);
        });
    };
    
}