"use strict";

function ListWithTitleAndActions($scope, ApplicationContext, templateManager, ScreenService) {

    let count = 5;

    $scope.openDetail = (afterClickOnItemWidget, curItem) => {
        templateManager.container.currentSubItem = curItem;
        let code = afterClickOnItemWidget;
        $scope.$eval(
            code,
            Object.assign({}, ApplicationContext, {
                args: {
                    owner: $scope.widget
                }
            })
        );
    };
    
    $scope.stopPropagation = e => {
        e.stopPropagation();
        count --;
        if(count < 0){
            count = 2;
            ScreenService.showMessage('TO_DELETE_PRESS_HOLD','exclamation');
        }
    };  
    
    $scope.doExcludeAction = (excludeAction, curItem) => {
        templateManager.container.itemToExclude = curItem;
        let code = excludeAction;
        $scope.$eval(
            code,
            Object.assign({}, ApplicationContext, {
                args: {
                    owner: $scope.widget
                }
            })
        );
    };

    $scope.selectLongTappedItem = item =>{
        if(item.__isSelected){
            if($scope.widget.beforeUnselectRow)
                $scope.widget.beforeUnselectRow();
            
            $scope.widget.dataSource.removeCheckedRows(item);

            if($scope.widget.afterUnselectRow)
                $scope.widget.afterUnselectRow();
        } else{
            if($scope.widget.beforeSelectRow)
                $scope.widget.beforeSelectRow();

            $scope.widget.dataSource.addCheckedRows(item);
            
            if($scope.widget.afterSelectRow)
                $scope.widget.afterSelectRow();
        }

    };

    $scope.onClickSquareItem = data => {
        if($scope.widget.hasCheckedRows()){
            $scope.selectLongTappedItem(data);
        } else {
            $scope.openDetail($scope.widget.afterClickOnItemWidget, data);
        }
    };

    $scope.trashIconClick = (data, $event)=>{
        $event.stopPropagation();
        if(!$scope.widget.hasCheckedRows()){
            $scope.doExcludeAction($scope.widget.excludeAction, data);
        }
    };
}