function ScrollSnapController($scope, $element, $timeout){

    let activateTab = (tabIndex, forceDigest = false) => {
        if(tabIndex < $scope.widgets.length){
            let previousActiveWidget = $scope.widgets[$scope.currentTabActiveTabIndex]; 
            previousActiveWidget.isTabActive = false;
            $scope.currentTabActiveTabIndex = tabIndex;
            let activeWidget = $scope.widgets[tabIndex]; 
            activeWidget.isTabActive = true;
            activeWidget.activate();
            headerScroll(tabIndex);
            if(forceDigest){
                $scope.$apply();
            }
        }
    };

    let changeActiveTabByScrollV2 = () => {
        let tabsContainer = $element[0].querySelector('.s-tabbedContent');
        clearTimeout($scope.scrollTimeoutID);
        $scope.scrollTimeoutID = setTimeout(() => {
            let lastScroll = Math.floor(tabsContainer.scrollLeft);
            let newIndex = Math.round((lastScroll/ tabsContainer.scrollWidth) * $scope.widgets.length);
            activateTab(newIndex, false);
        }, 200);
    };

    function headerScroll(indexOfTab) {
        const tabHeader = $element[0].querySelector('.s-tabbedHeader');
        const offsetLeft = tabHeader.children[indexOfTab].offsetLeft;
        tabHeader.scrollLeft = (offsetLeft - window.innerWidth/3);
    }

    $scope.initListener = () => {
        if(!$scope.listenerAttached){
            const tabsContainer = $element[0].querySelector('.s-tabbedContent');
            tabsContainer.addEventListener('touchend', changeActiveTabByScrollV2 ,false);
            $scope.listenerAttached = true;
        }
    };

    $scope.init = () => {
        $scope.currentTabActiveTabIndex = 0;
        if($scope.widgets && $scope.widgets.length > 0){
            $scope.widgets[0].isTabActive = true;
            $scope.widgets[0].activate();
        }
    };

    $scope.clickOntabHeaderEvent = (tabIndex) => {
        const pageSize = window.innerWidth;
        const tabsContainer = $element[0].querySelector('.s-tabbedContent');
        tabsContainer.scroll({
            left: tabIndex * pageSize,
            behavior: "smooth"
        });
        activateTab(tabIndex);
    };
};